package br.usp.ime.forum.business;

import java.util.List;

import br.usp.ime.forum.dao.AssuntoDAO;
import br.usp.ime.forum.model.Assunto;
import br.usp.ime.forum.model.Usuario;

public class AssuntoBusiness {

	private AssuntoDAO assuntoDAO = AssuntoDAO.getInstance();
	
	public List<Assunto> getTodosOsAssuntos() {		
		List<Assunto> assuntos = assuntoDAO.findTodosOsAssuntos();
		return assuntos;
	}

	public void cadastraAssunto(String titulo, String descricao,Usuario autor) {		
		Assunto assunto = new Assunto(titulo,descricao,autor);		
		assuntoDAO.cadastra(assunto);
	}

	public Assunto getAssuntoPorId(Long idAssunto) {	
		Assunto assunto = assuntoDAO.findAssuntoPorId(idAssunto);
		return assunto;
	}

	public void excluiAssunto(Long idAssunto) {
		Assunto assunto = assuntoDAO.findAssuntoPorId(idAssunto);
		assuntoDAO.exclui(assunto);
	}

	public void editaAssunto(Long idAssunto, String titulo, String descricao) {
		Assunto assuntoAntigo = assuntoDAO.findAssuntoPorId(idAssunto);
		Assunto novoAssunto = AssuntoDAO.getInstance().clone(assuntoAntigo);
		novoAssunto.setTitulo(titulo);
		novoAssunto.setDescricao(descricao);
		AssuntoDAO.getInstance().altera(assuntoAntigo, novoAssunto);
	}

}
