package br.usp.ime.forum.business;

import java.sql.Timestamp;
import java.util.Date;
import java.util.List;

import br.usp.ime.forum.dao.MensagemDAO;
import br.usp.ime.forum.model.Mensagem;
import br.usp.ime.forum.model.Topico;
import br.usp.ime.forum.model.Usuario;

public class MensagemBusiness {

	private MensagemDAO mensagemDAO = MensagemDAO.getInstance();
	
	public List<Mensagem> getMensagensDoUsuario(Usuario usuario) {
		List<Mensagem> mensagensDoUsuario = mensagemDAO.getMensagensDoUsuario(usuario);
		return mensagensDoUsuario;
	}
	
	public List<Mensagem> getMensagensDoTopico(Topico topico) {
		List<Mensagem> mensagensDoUsuario = mensagemDAO.getMensagensDoTopico(topico);
		return mensagensDoUsuario;
	}

	public List<Mensagem> getMensagensContendoTexto(String texto) {
		List<Mensagem> mensagensContendoTexto = mensagemDAO.getMensagensContendoTexto(texto);
		return mensagensContendoTexto;
	}

	public Mensagem adicionaMensagem(Long idTopico, String textoMensagem,Usuario autor) {
		TopicoBusiness topicoBusiness = new TopicoBusiness();
		Topico topico = topicoBusiness.getTopicoById(idTopico);
		Timestamp criacao = new Timestamp(new Date().getTime());
		Mensagem mensagem = topico.adicionaMensagem(textoMensagem,autor,criacao);
		Mensagem mensagemAdicionada = mensagemDAO.adiciona(mensagem);
		return mensagemAdicionada;
	}

	public void removeMensagem(Long idTopico, Long idMensagem) {
		TopicoBusiness topicoBusiness = new TopicoBusiness();
		Topico topico = topicoBusiness.getTopicoById(idTopico);
		Mensagem mensagem = getMensagemPorId(idMensagem);
		removeMensagem(topico, mensagem);
	}

	private Mensagem getMensagemPorId(Long idMensagem) {
		Mensagem mensagem = mensagemDAO.getMensagemPorId(idMensagem);
		return mensagem;
	}

	public void removeMensagem(Topico topico, Mensagem mensagem) {
		topico.removeMensagem(mensagem);
		mensagemDAO.remove(mensagem);
	}

}
