package br.usp.ime.forum.business;

import java.util.ArrayList;
import java.util.List;
import br.usp.ime.forum.dao.TopicoDAO;
import br.usp.ime.forum.model.Assunto;
import br.usp.ime.forum.model.Mensagem;
import br.usp.ime.forum.model.Topico;
import br.usp.ime.forum.model.Usuario;

public class TopicoBusiness {

	private TopicoDAO topicoDAO = TopicoDAO.getInstance();
	
	public void criaTopico(Long idAssunto, String titulo, String descricao, Usuario usuario) {
		
		AssuntoBusiness assuntoBusiness = new AssuntoBusiness();
		Assunto assunto = assuntoBusiness.getAssuntoPorId(idAssunto);
		Topico topico = assunto.adicionaTopico(titulo ,descricao, usuario);
		
		topicoDAO.cadastra(topico);
	}
	
	public List<Topico> listarTodos(){
		return topicoDAO.listarTodos();
	}
	
	public void excluirTopico(Long idTopico){
		Topico topico = topicoDAO.findById(idTopico);
		List<Mensagem> mensagens = topico.getMensagens();	
		MensagemBusiness business = new MensagemBusiness();
		List<Mensagem> mensagensASeremExcluidas = new ArrayList<Mensagem>(mensagens);
		for (Mensagem mensagem : mensagensASeremExcluidas) {
			business.removeMensagem(topico,mensagem);
		}	
		topicoDAO.excluir(topico);
	}
	
	public Topico getTopicoById(Long idTopico) {		
		Topico topicoComId = topicoDAO.findById(idTopico);
		return topicoComId;
	}

	public List<Topico> getTopicosDoUsuario(Usuario usuario) {
		List<Topico> topicosDoUsuario = topicoDAO.findPorUsuario(usuario);
		return topicosDoUsuario;
	}

	public List<Topico> getTopicosComTituloOuDescricaoContendoTexto(String texto) {
		List<Topico> topicosComFiltro = topicoDAO.findPorTituloOuDescricaoContentoTexto(texto);
		return topicosComFiltro;
	}
	
	

}
