package br.usp.ime.forum.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import br.usp.ime.forum.bancoDados.Conexao;
import br.usp.ime.forum.bancoDados.QueryMaker;
import br.usp.ime.forum.model.Assunto;
import br.usp.ime.forum.model.Usuario;

public class AssuntoDAO {
	
	private static final AssuntoDAO INSTANCE = new AssuntoDAO();
	

	public static AssuntoDAO getInstance(){
		return INSTANCE;
	}
	
	private AssuntoDAO(){
		
	}
	
	
	public List<Assunto> findTodosOsAssuntos() {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Assunto assunto = null;
		List<Assunto> todos = new ArrayList<Assunto>();
		try {
			statement = con.createStatement();

			resultSet = statement.executeQuery("SELECT * FROM assuntos;");

			while (resultSet.next()) {
				Long id = resultSet.getLong("id");
				Long idAutor = resultSet.getLong("idAutor");
				String titulo = resultSet.getString("titulo");
				String descricao = resultSet.getString("descricao");				

				Usuario autor = UsuarioDAO.getInstance().findById(idAutor);
				assunto = new Assunto(titulo, descricao, autor );//TODO #
				assunto.setId(id);

				todos.add(assunto);
			}

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return todos;
	}

	
	public void cadastra(Assunto assunto) {
		
		assunto.setId(getIdMaximo() + 1);

		Connection con = Conexao.getConnection();
		Statement statement;

		try {
			statement = con.createStatement();

			List<String> parametros = new ArrayList<String>();
			parametros.add(assunto.getId().toString());
			parametros.add(assunto.getAutor().getId().toString());
			parametros.add(assunto.getTitulo());
			parametros.add(assunto.getDescricao());

			String query = "INSERT INTO assuntos VALUES";
			query += QueryMaker.makeParameters(parametros);

			statement.execute(query);

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
	}


	private Long getIdMaximo(){
		Long idMaximo = 0L;
		Connection con = Conexao.getConnection();
		PreparedStatement stmt;
		try {
			stmt = con.prepareStatement("select max(id) as id_maximo from assuntos");
			ResultSet rs = stmt.executeQuery();
			if(rs.next()){
				idMaximo = rs.getLong("id_maximo");
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return idMaximo;
	}
	
	public Assunto findAssuntoPorId(Long idAssunto) {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Assunto assunto = null;
		try {
			statement = con.createStatement();

			StringBuffer query = new StringBuffer();
			query.append("SELECT * FROM assuntos WHERE id =");
			query.append("'");
			query.append(idAssunto);
			query.append("';");

			resultSet = statement.executeQuery(query.toString());
			resultSet.next();

			Long id = resultSet.getLong("id");
			Long idAutor = resultSet.getLong("idAutor");
			String titulo = resultSet.getString("titulo");
			String descricao = resultSet.getString("descricao");
			
			Usuario autor = UsuarioDAO.getInstance().findById(idAutor);
			assunto = new Assunto(titulo, descricao, autor);//TODO #
			assunto.setId(id);

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return assunto;
	}
	

	
	public void exclui(Assunto assunto) {

		Connection con = Conexao.getConnection();
		Statement statement;
		StringBuffer query = new StringBuffer();
		Long id = assunto.getId();
		try {
			statement = con.createStatement();

			query.append("DELETE FROM assuntos WHERE id =");
			query.append(id);
			query.append(";");
			
			System.out.println(query);
			statement.execute(query.toString());
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
	}
	

	
	public Assunto clone(Assunto assunto){
		Assunto clone = new Assunto(assunto.getTitulo(), assunto.getDescricao(), assunto.getAutor());
		clone.setId(assunto.getId());
		clone.setTopicos(assunto.getTopicos());
		return clone;
	}
	
	public void altera(Assunto assuntoAnterior, Assunto assuntoNovo) {
		exclui(assuntoAnterior);
		cadastra(assuntoNovo);
	}
	

}
