package br.usp.ime.forum.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Random;
import java.util.Set;

import br.usp.ime.forum.bancoDados.Conexao;
import br.usp.ime.forum.bancoDados.QueryMaker;
import br.usp.ime.forum.model.Mensagem;
import br.usp.ime.forum.model.Topico;
import br.usp.ime.forum.model.Usuario;

public class MensagemDAO {

	private static MensagemDAO INSTANCIA = new MensagemDAO();

	private MensagemDAO() {

	}

	public static MensagemDAO getInstance() {
		return INSTANCIA;
	}

//	public List<Mensagem> getMensagensDoUsuario(Usuario usuario) {
//		List<Mensagem> mensagensDoUsuario = new ArrayList<Mensagem>();
//		for (Mensagem mensagemAtual : mensagens) {
//			Usuario autorAtual = mensagemAtual.getAutor();
//			if (autorAtual.equals(usuario)) {
//				mensagensDoUsuario.add(mensagemAtual);
//			}
//		}
//		return mensagensDoUsuario;
//	}
	
	public List<Mensagem> getMensagensDoUsuario(Usuario usuario) {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Mensagem mensagem = null;
		List<Mensagem> todos = new ArrayList<Mensagem>();
		try {
			statement = con.createStatement();
			
			StringBuffer query = new StringBuffer();
			query.append("SELECT * FROM mensagens WHERE idAutor =");
			query.append(usuario.getId());
			query.append(";");
			
			resultSet = statement.executeQuery(query.toString());

			while (resultSet.next()) {
				Long id = resultSet.getLong("id");
				Long idTopico = resultSet.getLong("idTopico");
				Long idAutor = resultSet.getLong("idAutor");
				String texto = resultSet.getString("texto");
				Timestamp criacao = new Timestamp(resultSet.getLong("criacaoMili"));
				
				Usuario autor = UsuarioDAO.getInstance().findById(idAutor);
				Topico topico = TopicoDAO.getInstance().findById(idTopico);
				
				mensagem = new Mensagem(texto, topico, autor, criacao);			
				mensagem.setId(id);

				todos.add(mensagem);
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return todos;
	}
	
	public List<Mensagem> getMensagensDoTopico(Topico topico) {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Mensagem mensagem = null;
		List<Mensagem> todos = new ArrayList<Mensagem>();
		try {
			statement = con.createStatement();
			
			StringBuffer query = new StringBuffer();
			query.append("SELECT * FROM mensagens WHERE idTopico =");
			query.append(topico.getId());
			query.append(";");
			
			resultSet = statement.executeQuery(query.toString());

			while (resultSet.next()) {
				Long id = resultSet.getLong("id");
				Long idAutor = resultSet.getLong("idAutor");
				String texto = resultSet.getString("texto");
				Timestamp criacao = new Timestamp(resultSet.getLong("criacaoMili"));
				
				Usuario autor = UsuarioDAO.getInstance().findById(idAutor);
				
				mensagem = new Mensagem(texto, topico, autor, criacao);			
				mensagem.setId(id);

				todos.add(mensagem);
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return todos;
	}
	

	public List<Mensagem> getMensagensContendoTexto(String texto) {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Usuario usuario = null;
		List<Mensagem> provaveis = new ArrayList<Mensagem>();
		try {
			statement = con.createStatement();
			StringBuffer query = new StringBuffer();
			query.append("SELECT * FROM mensagens WHERE texto ~* ");
			query.append("'.*");
			query.append(texto);
			query.append(".*';");
			resultSet = statement.executeQuery(query.toString());

			while (resultSet.next()) {
				Long id = resultSet.getLong("id");
				Long idAutor = resultSet.getLong("idAutor");
				Long idTopico = resultSet.getLong("idTopico");
				String textoMensagem = resultSet.getString("texto");
				Timestamp criacao = new Timestamp(resultSet.getLong("criacaoMili"));
				
				Usuario autor = UsuarioDAO.getInstance().findById(idAutor);
				Topico topico = TopicoDAO.getInstance().findById(idTopico);
				
				Mensagem mensagem = new Mensagem(textoMensagem, topico, autor, criacao);			
				mensagem.setId(id);

				provaveis.add(mensagem);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return provaveis;
	}

	
	public Mensagem adiciona(Mensagem mensagem) {
		mensagem.setId(getIdMaximo() + 1);

		Connection con = Conexao.getConnection();
		Statement statement;

		try {
			statement = con.createStatement();

			List<String> parametros = new ArrayList<String>();
			parametros.add(mensagem.getId().toString());
			parametros.add(mensagem.getTopico().getId().toString());
			parametros.add(mensagem.getAutor().getId().toString());
			parametros.add(mensagem.getTexto());
			parametros.add(Long.toString(mensagem.getCriacao().getTime()));

			String query = "INSERT INTO mensagens VALUES";
			query += QueryMaker.makeParameters(parametros);

			statement.execute(query);

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return mensagem;
	}


	private Long getIdMaximo(){
		Long idMaximo = 0L;
		Connection con = Conexao.getConnection();
		PreparedStatement stmt;
		try {
			stmt = con.prepareStatement("select max(id) as id_maximo from mensagens");
			ResultSet rs = stmt.executeQuery();
			if(rs.next()){
				idMaximo = rs.getLong("id_maximo");
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return idMaximo;
	}

//	public Mensagem getMensagemPorId(Long idMensagem) {
//		for (Mensagem mensagemAtual : mensagens) {
//			Long idAtual = mensagemAtual.getId();
//			if (idAtual.equals(idMensagem))
//				return mensagemAtual;
//		}
//		return null;
//	}
	
	public Mensagem getMensagemPorId(Long idMensagem) {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Mensagem mensagem = null;
		try {
			statement = con.createStatement();

			StringBuffer query = new StringBuffer();
			query.append("SELECT * FROM mensagens WHERE id =");
			query.append("'");
			query.append(idMensagem);
			query.append("';");

			resultSet = statement.executeQuery(query.toString());
			resultSet.next();

			Long id = resultSet.getLong("id");
			Long idTopico = resultSet.getLong("idTopico");
			Long idAutor = resultSet.getLong("idAutor");
			String texto = resultSet.getString("texto");
			Timestamp criacao = new Timestamp(resultSet.getLong("criacaoMili"));
			
			Usuario autor = UsuarioDAO.getInstance().findById(idAutor);
			Topico topico = TopicoDAO.getInstance().findById(idTopico);
			
			mensagem = new Mensagem(texto, topico, autor, criacao);			
			mensagem.setId(id);

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return mensagem;
	}

//	public void remove(Mensagem mensagem) {
//		mensagens.remove(mensagem);
//	}
	
	public void remove(Mensagem mensagem){

		Connection con = Conexao.getConnection();
		Statement statement;
		StringBuffer query = new StringBuffer();
		Long id = mensagem.getId();
		try {
			statement = con.createStatement();

			query.append("DELETE FROM mensagens WHERE id =");
			query.append(id);
			query.append(";");
			
			statement.execute(query.toString());
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
	}

}
