package br.usp.ime.forum.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import br.usp.ime.forum.bancoDados.Conexao;
import br.usp.ime.forum.bancoDados.QueryMaker;
import br.usp.ime.forum.model.Assunto;
import br.usp.ime.forum.model.Mensagem;
import br.usp.ime.forum.model.Topico;
import br.usp.ime.forum.model.Usuario;

public class TopicoDAO {
		
	private static final TopicoDAO INSTANCIA = new TopicoDAO();
	
	private TopicoDAO(){
		
	}

	public static TopicoDAO getInstance(){
		return INSTANCIA;
	}

	
	public List<Topico> findPorUsuario(Usuario usuario) {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Topico topico = null;
		List<Topico> todos = new ArrayList<Topico>();
		try {
			statement = con.createStatement();
			
			StringBuffer query = new StringBuffer();
			query.append("SELECT * FROM topicos WHERE idAutor =");
			query.append(usuario.getId());
			query.append(";");
			
			resultSet = statement.executeQuery(query.toString());

			while (resultSet.next()) {
				Long id = resultSet.getLong("id");
				Long idAssunto = resultSet.getLong("idAssunto");
				Long idAutor = resultSet.getLong("idAutor");
				String titulo = resultSet.getString("titulo");
				String descricao = resultSet.getString("descricao");
				
				Assunto assunto = AssuntoDAO.getInstance().findAssuntoPorId(idAssunto);
				Usuario autor = UsuarioDAO.getInstance().findById(idAutor);
				
				topico = new Topico(titulo, descricao, assunto,autor );
				topico.setId(id);
				
				todos.add(topico);
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return todos;
	}

//	public void cadastra(Topico topico) {
//		Long maxId = getMaxId();
//		topico.setId(maxId + 1);
//		topicos.add(topico);		
//	}
	
	public void cadastra(Topico topico) {
		topico.setId(getIdMaximo() + 1);

		Connection con = Conexao.getConnection();
		Statement statement;

		try {
			statement = con.createStatement();

			List<String> parametros = new ArrayList<String>();
			parametros.add(topico.getId().toString());
			parametros.add(topico.getAssunto().getId().toString());
			parametros.add(topico.getAutor().getId().toString());
			parametros.add(topico.getTitulo());
			parametros.add(topico.getDescricao());

			String query = "INSERT INTO topicos VALUES";
			query += QueryMaker.makeParameters(parametros);

			statement.execute(query);

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
	}

	

	private Long getIdMaximo(){
		Long idMaximo = 0L;
		Connection con = Conexao.getConnection();
		PreparedStatement stmt;
		try {
			stmt = con.prepareStatement("select max(id) as id_maximo from topicos");
			ResultSet rs = stmt.executeQuery();
			if(rs.next()){
				idMaximo = rs.getLong("id_maximo");
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return idMaximo;
	}
	
//	public List<Topico> listarTodos(){
//		return topicos;
//	}
	
	public List<Topico> listarTodos() {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Topico topico = null;
		List<Topico> todos = new ArrayList<Topico>();
		try {
			statement = con.createStatement();

			resultSet = statement.executeQuery("SELECT * FROM topicos;");

			while (resultSet.next()) {
				Long id = resultSet.getLong("id");
				Long idAssunto = resultSet.getLong("idAssunto");
				Long idAutor = resultSet.getLong("idAutor");
				String titulo = resultSet.getString("titulo");
				String descricao = resultSet.getString("descricao");
				
				Assunto assunto = AssuntoDAO.getInstance().findAssuntoPorId(idAssunto);
				Usuario autor = UsuarioDAO.getInstance().findById(idAutor);
				
				topico = new Topico(titulo, descricao, assunto,autor );
				topico.setId(id);
				
				todos.add(topico);
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return todos;
	}
	
//	public Topico findById(Long id){
//		for(Topico topico : topicos){
//			if(topico.getId().equals(id)){
//				return topico;
//			}
//		}
//		return null;
//	}
	
	public Topico findById(Long idTopico) {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Topico topico = null;
		try {
			statement = con.createStatement();

			StringBuffer query = new StringBuffer();
			query.append("SELECT * FROM topicos WHERE id =");
			query.append("'");
			query.append(idTopico);
			query.append("';");

			resultSet = statement.executeQuery(query.toString());
			resultSet.next();
			
			Long id = resultSet.getLong("id");
			Long idAssunto = resultSet.getLong("idAssunto");
			Long idAutor = resultSet.getLong("idAutor");
			String titulo = resultSet.getString("titulo");
			String descricao = resultSet.getString("descricao");
			
			Assunto assunto = AssuntoDAO.getInstance().findAssuntoPorId(idAssunto);
			Usuario autor = UsuarioDAO.getInstance().findById(idAutor);
			
			topico = new Topico(titulo, descricao, assunto, autor );
			topico.setId(id);

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return topico;
	}
	
//	public boolean excluir(Topico topico){
//		return topicos.remove(topico);
//		
//	}
	
	public void excluir(Topico topico) {

		Connection con = Conexao.getConnection();
		Statement statement;
		StringBuffer query = new StringBuffer();
		Long id = topico.getId();
		try {
			statement = con.createStatement();

			query.append("DELETE FROM topicos WHERE id =");
			query.append(id);
			query.append(";");
			
			statement.execute(query.toString());
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
	}

//	public List<Topico> findPorTituloOuDescricaoContentoTexto(String texto) {
//		List<Topico> topicosFiltrados = new ArrayList<Topico>();
//		for (Topico topico : topicos) {
//			String titulo = topico.getTitulo();
//			String descricao = topico.getDescricao();
//			if(titulo.contains(texto) || descricao.contains(texto)){
//				topicosFiltrados.add(topico);
//			}
//		}
//		return topicosFiltrados;
//	}
	
	public List<Topico> findPorTituloOuDescricaoContentoTexto(String texto) {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Topico topico = null;
		List<Topico> provaveis = new ArrayList<Topico>();
		try {
			statement = con.createStatement();
			StringBuffer query = new StringBuffer();
			query.append("SELECT * FROM topicos WHERE titulo ~* ");
			query.append("'.*");
			query.append(texto);
			query.append(".*'");
			query.append("OR descricao ~* ");
			query.append("'.*");
			query.append(texto);
			query.append(".*';");
			resultSet = statement.executeQuery(query.toString());

			while (resultSet.next()) {
				Long id = resultSet.getLong("id");
				Long idAssunto = resultSet.getLong("idAssunto");
				Long idAutor = resultSet.getLong("idAutor");
				String titulo = resultSet.getString("titulo");
				String descricao = resultSet.getString("descricao");
				
				Assunto assunto = AssuntoDAO.getInstance().findAssuntoPorId(idAssunto);
				Usuario autor = UsuarioDAO.getInstance().findById(idAutor);
				
				topico = new Topico(titulo, descricao, assunto, autor );
				topico.setId(id);
				
				provaveis.add(topico);
			}

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return provaveis;
	}
	

	
	

}
