package br.usp.ime.forum.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import br.usp.ime.forum.bancoDados.Conexao;
import br.usp.ime.forum.bancoDados.QueryMaker;
import br.usp.ime.forum.model.Privilegio;
import br.usp.ime.forum.model.Usuario;

public class UsuarioDAO {


	public static Usuario ADMINISTRADOR_1;
	public static Usuario MODERADOR_1;
	public static Usuario USUARIO_1;

	private static final UsuarioDAO INSTANCE = new UsuarioDAO();

	private static Usuario visitante = null;
	
	public static Usuario getVisitante(){
		if(visitante == null){
			visitante = new Usuario("Visitante","visitante@forum.ime.usp.br", "visitante", null);
			visitante.setPrivilegio(Privilegio.VISITANTE);
		}
		return visitante;
		
	}
			

	public static UsuarioDAO getInstance() {
		return INSTANCE;
	}
	
	private UsuarioDAO() {
	}

	public void cadastraUsuario(Usuario novoUsuario) {
		novoUsuario.setId(getIdMaximo() + 1);

		Connection con = Conexao.getConnection();
		Statement statement;

		try {
			statement = con.createStatement();

			List<String> parametros = new ArrayList<String>();
			parametros.add(novoUsuario.getId().toString());
			parametros.add(novoUsuario.getNome());
			parametros.add(novoUsuario.getEmail());
			parametros.add(novoUsuario.getNomeDeUsuario());
			parametros.add(novoUsuario.getSenha());
			parametros.add(Boolean.toString(novoUsuario.isAutorizado()));
			parametros.add(novoUsuario.getPrivilegio().toString());
			
			

			String query = "INSERT INTO usuarios VALUES";
			query += QueryMaker.makeParameters(parametros);
			
			statement.execute(query);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
	}
	
	public void autorizaUsuario(Long idUsuario){
		Usuario usuarioAnterior = findById(idUsuario);
		Usuario usuarioNovo = clone(usuarioAnterior);
		usuarioNovo.setAutorizado(true);
		altera(usuarioAnterior, usuarioNovo);
	}

//	private Long getMaxId() {
//		Long idMaximo = 0L;
//		for (Usuario usuarioAtual : usuarios) {
//			Long idAtual = usuarioAtual.getId();
//			if (idAtual > idMaximo)
//				idMaximo = idAtual;
//		}
//		return idMaximo;
//	}
	
	private Long getIdMaximo(){
		Long idMaximo = 0L;
		Connection con = Conexao.getConnection();
		PreparedStatement stmt;
		try {
			stmt = con.prepareStatement("select max(id) as id_maximo from usuarios");
			ResultSet rs = stmt.executeQuery();
			if(rs.next()){
				idMaximo = rs.getLong("id_maximo");
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return idMaximo;
	}

	// public Usuario findUsuarioPorNomeDeUsuarioESenha2(String nomeDeUsuario,
	// String senha) {
	// for (Usuario usuarioAtual : usuarios) {
	// String nomeDeUsuarioAtual = usuarioAtual.getNomeDeUsuario();
	// String senhaAtual = usuarioAtual.getSenha();
	// if (nomeDeUsuarioAtual.equals(nomeDeUsuario)
	// && senhaAtual.equals(senha))
	// return usuarioAtual;
	//
	// }
	// return null;
	// }

	public Usuario findUsuarioPorNomeDeUsuarioESenha(String nomeDeUsuario,
			String senhaDeUsuario) {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Usuario usuario = null;
		try {
			statement = con.createStatement();

			StringBuffer query = new StringBuffer();
			query.append("SELECT * FROM usuarios WHERE usuario =");
			query.append("'");
			query.append(nomeDeUsuario);
			query.append("'");
			query.append("AND senha =");
			query.append("'");
			query.append(senhaDeUsuario);
			query.append("';");
			
			resultSet = statement.executeQuery(query.toString());
			resultSet.next();

			String nome = resultSet.getString("nome");
			String nick = resultSet.getString("usuario");
			String email = resultSet.getString("email");
			String senha = resultSet.getString("senha");
			Boolean autorizado = resultSet.getBoolean("autorizado");
			Privilegio privilegio = Privilegio.valueOf(resultSet.getString("privilegio"));
			Long id = resultSet.getLong("id");
			usuario = new Usuario(nome, email, nick, senha);
			usuario.setId(id);
			usuario.setAutorizado(autorizado);
			usuario.setPrivilegio(privilegio);

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return usuario;
	}

	// public List<Usuario> findNaoAutorizados() {
	// List<Usuario> usuariosNaoAutorizados = new ArrayList<Usuario>();
	// for (Usuario usuarioAtual : usuarios) {
	// if (!usuarioAtual.isAutorizado())
	// usuariosNaoAutorizados.add(usuarioAtual);
	// }
	// return usuariosNaoAutorizados;
	// }

	public List<Usuario> findNaoAutorizados() {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Usuario usuario = null;
		List<Usuario> provaveis = new ArrayList<Usuario>();
		try {
			statement = con.createStatement();
			resultSet = statement
					.executeQuery("SELECT * FROM usuarios WHERE autorizado = false");

			while (resultSet.next()) {
				String nome = resultSet.getString("nome");
				String nick = resultSet.getString("usuario");
				String email = resultSet.getString("email");
				String senha = resultSet.getString("senha");
				Boolean autorizado = resultSet.getBoolean("autorizado");
				Long id = resultSet.getLong("id");

				usuario = new Usuario(nome, email, nick, senha);
				usuario.setId(id);
				usuario.setAutorizado(autorizado);

				provaveis.add(usuario);

			}

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return provaveis;
	}

	// public Usuario findById(Long idUsuario) {
	// for (Usuario usuarioAtual : usuarios) {
	// Long idUsuarioAtual = usuarioAtual.getId();
	// if (idUsuarioAtual.equals(idUsuario))
	// return usuarioAtual;
	// }
	// return null;
	// }

	public Usuario findById(Long idUsuario) {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Usuario usuario = null;
		try {
			statement = con.createStatement();

			StringBuffer query = new StringBuffer();
			query.append("SELECT * FROM usuarios WHERE id =");
			query.append("'");
			query.append(idUsuario);
			query.append("';");

			resultSet = statement.executeQuery(query.toString());
			resultSet.next();

			String nome = resultSet.getString("nome");
			String nick = resultSet.getString("usuario");
			String email = resultSet.getString("email");
			String senha = resultSet.getString("senha");
			Boolean autorizado = resultSet.getBoolean("autorizado");
			Long id = resultSet.getLong("id");

			usuario = new Usuario(nome, email, nick, senha);
			usuario.setId(id);
			usuario.setAutorizado(autorizado);

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return usuario;
	}

	// public List<Usuario> findByNameOrNickname2(String piece) {
	//
	// List<Usuario> provaveis = new ArrayList<Usuario>();
	//
	// for (Usuario usuario : usuarios) {
	//
	// if (usuario.getNome().contains(piece)
	// || usuario.getNomeDeUsuario().contains(piece)) {
	// provaveis.add(usuario);
	// }
	// }
	// return provaveis;
	// }

	public List<Usuario> findByNameOrNickname(String piece) {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Usuario usuario = null;
		List<Usuario> provaveis = new ArrayList<Usuario>();
		try {
			statement = con.createStatement();
			StringBuffer query = new StringBuffer();
			query.append("SELECT * FROM usuarios WHERE nome ~* ");
			query.append("'.*");
			query.append(piece);
			query.append(".*'");
			query.append("OR usuario ~* ");
			query.append("'.*");
			query.append(piece);
			query.append(".*';");
			resultSet = statement.executeQuery(query.toString());

			while (resultSet.next()) {
				String nome = resultSet.getString("nome");
				String nick = resultSet.getString("usuario");
				String email = resultSet.getString("email");
				String senha = resultSet.getString("senha");
				Boolean autorizado = resultSet.getBoolean("autorizado");
				Long id = resultSet.getLong("id");

				usuario = new Usuario(nome, email, nick, senha);
				usuario.setId(id);
				usuario.setAutorizado(autorizado);

				provaveis.add(usuario);
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return provaveis;
	}

	// public List<Usuario> findTodos() {
	// List<Usuario> todos = new ArrayList<Usuario>(usuarios);
	// return todos;
	// }

	public List<Usuario> findTodos() {

		Connection con = Conexao.getConnection();
		Statement statement;
		ResultSet resultSet;
		Usuario usuario = null;
		List<Usuario> todos = new ArrayList<Usuario>();
		try {
			statement = con.createStatement();

			resultSet = statement.executeQuery("SELECT * FROM usuarios;");

			while (resultSet.next()) {
				String nome = resultSet.getString("nome");
				String nick = resultSet.getString("usuario");
				String email = resultSet.getString("email");
				String senha = resultSet.getString("senha");
				Privilegio privilegio = Privilegio.valueOf(resultSet.getString("privilegio"));
				Long id = resultSet.getLong("id");

				usuario = new Usuario(nome, email, nick, senha);
				usuario.setId(id);
				usuario.setPrivilegio(privilegio);

				todos.add(usuario);

			}

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
		return todos;
	}

	// public void altera(Usuario usuarioAnterior, Usuario usuarioNovo) {
	// Long idUsuarioAnterior = usuarioAnterior.getId();
	// usuarioNovo.setId(idUsuarioAnterior);
	// usuarios.remove(usuarioAnterior);
	// usuarios.add(usuarioNovo);
	// }

	public void altera(Usuario usuarioAnterior, Usuario usuarioNovo) {


		Connection con = Conexao.getConnection();
		PreparedStatement stmt;
		try {
			stmt = con.prepareStatement("update usuarios set nome = ?,email = ?,usuario = ?,senha = ?,autorizado = ? where id = ?");

			stmt.setString(1,usuarioNovo.getNome());
			stmt.setString(2,usuarioNovo.getEmail());
			stmt.setString(3,usuarioNovo.getNomeDeUsuario());
			stmt.setString(4,usuarioNovo.getSenha());
			stmt.setBoolean(5,usuarioNovo.getAutorizado());
			stmt.setLong(6,usuarioAnterior.getId());
			stmt.execute();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void remove(Usuario usuario) {

		Connection con = Conexao.getConnection();
		Statement statement;
		StringBuffer query = new StringBuffer();
		Long id = usuario.getId();
		try {
			statement = con.createStatement();

			query.append("DELETE FROM usuarios WHERE id =");
			query.append(id);
			query.append(";");

			statement.execute(query.toString());
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Conexao.fechaConexao();
	}

	
	public Usuario clone(Usuario usuario){
		Usuario clone = new Usuario(usuario.getNome(), usuario.getEmail(), usuario.getNomeDeUsuario(), usuario.getSenha());
		clone.setId(usuario.getId());
		clone.setAutorizado(usuario.getAutorizado());
		clone.setPrivilegio(usuario.getPrivilegio());
		return clone;
	}

}
