package br.usp.ime.forum.model;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class Topico {

	private Long id;
	private String titulo;
	private String descricao;
	private Assunto assunto;
	private Usuario autor;
	private List<Mensagem> mensagens = new ArrayList<Mensagem>();
	
	public Topico(String titulo, String descricao, Assunto assunto,Usuario autor) {
		this.titulo = titulo;
		this.descricao = descricao;
		this.assunto = assunto;
		this.autor = autor;
	}
	

	public Mensagem adicionaMensagem(String textoMensagem, Usuario autor,Timestamp criacao) {
		Mensagem mensagem = new Mensagem(textoMensagem,this,autor,criacao);
		mensagens.add(mensagem);
		return mensagem;
	}

	public void removeMensagem(Mensagem mensagem) {
		mensagens.remove(mensagem);
	}
	
	public Assunto getAssunto() {
		return assunto;
	}
	public void setAssunto(Assunto assunto) {
		this.assunto = assunto;
	}
	public Usuario getAutor() {
		return autor;
	}
	public void setAutor(Usuario autor) {
		this.autor = autor;
	}
	public String getTitulo() {
		return titulo;
	}
	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}
	public String getDescricao() {
		return descricao;
	}
	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public List<Mensagem> getMensagens() {
		return mensagens;
	}
	public void setMensagens(List<Mensagem> mensagens) {
		this.mensagens = mensagens;
	}

	
	
}
