package br.usp.ime.forum.model;


public class Usuario {

	private Long id;
	private String nome;
	private String email;
	private String nomeDeUsuario;
	private String senha;
	private boolean autorizado;
	private Privilegio privilegio = Privilegio.COMUM;
	
	public Usuario(String nome, String email, String nomeDeUsuario,
			String senha) {
		this.nome = nome;
		this.email = email;
		this.nomeDeUsuario = nomeDeUsuario;
		this.senha = senha;
	}
		
	public Privilegio getPrivilegio() {
		return privilegio;
	}

	public void setPrivilegio(Privilegio privilegio) {
		this.privilegio = privilegio;
	}

	public Usuario(String nome, String email, String nomeDeUsuario,String senha, boolean autorizado) {
		this(nome,email,nomeDeUsuario,senha);
		this.autorizado = autorizado;
	}

//	public String getTipoDeUsuario(){
//		Class<? extends Usuario> classeAtual = this.getClass();
//		return classeAtual.getSimpleName();
//	}
	public Privilegio getTipoDeUsuario(){
		return this.getPrivilegio();
	}
	
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public String getNomeDeUsuario() {
		return nomeDeUsuario;
	}
	public void setNomeDeUsuario(String usuario) {
		this.nomeDeUsuario = usuario;
	}
	public String getSenha() {
		return senha;
	}
	public void setSenha(String senha) {
		this.senha = senha;
	}
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public boolean isAutorizado() {
		return autorizado;
	}
	public void setAutorizado(boolean autorizado) {
		this.autorizado = autorizado;
	}
	
	public boolean getAutorizado(){
		return this.autorizado;
	}
}
