package br.usp.ime.forum.servlet;

import java.io.IOException;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.usp.ime.forum.business.MensagemBusiness;
import br.usp.ime.forum.business.TopicoBusiness;
import br.usp.ime.forum.model.Mensagem;
import br.usp.ime.forum.model.Topico;

@SuppressWarnings("serial")
public class BuscarTopicosMensagensServlet extends HttpServlet {

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String textoParaConsulta = request.getParameter("textoParaBusca");		
		preparaTopicos(textoParaConsulta, request);
		preparaMensagens(textoParaConsulta, request);
		despachaParaPagina(request,response);
	}
	private void preparaMensagens(String textoParaConsulta,HttpServletRequest request) {
		MensagemBusiness mensagemBusiness = new MensagemBusiness();
		List<Mensagem> mensagens = mensagemBusiness.getMensagensContendoTexto(textoParaConsulta);
		request.setAttribute("mensagens", mensagens);
	}

	private void preparaTopicos(String textoParaConsulta,HttpServletRequest request) {
		TopicoBusiness topicoBusiness = new TopicoBusiness();
		List<Topico> topicos = topicoBusiness.getTopicosComTituloOuDescricaoContendoTexto(textoParaConsulta);
		request.setAttribute("topicos", topicos);
	}


	private void despachaParaPagina(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException {
		RequestDispatcher dispatcher = request.getRequestDispatcher("/buscar_topicos_mensagens.jsp");
		dispatcher.forward(request, response);
	}

}
