package br.usp.ime.forum.servlet;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.usp.ime.forum.business.UsuarioBusiness;
import br.usp.ime.forum.ex.SenhaEConfirmacaoDiferentesException;

@SuppressWarnings("serial")
public class CadastrarUsuarioServlet extends HttpServlet {

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String nome = request.getParameter("nome");
		String email = request.getParameter("email");
		String usuario = request.getParameter("usuario");
		String senha = request.getParameter("senha");
		String confirmacaoSenha = request.getParameter("confirmacaoSenha");
		
		UsuarioBusiness business = new UsuarioBusiness();
		try {
			business.cadastraUsuario(nome,email,usuario,senha,confirmacaoSenha);
		} catch (SenhaEConfirmacaoDiferentesException e) {
			redireciona("/cadastrar_usuario.jsp",request,response);
			e.printStackTrace();
		}
		setMensagem("Usurio cadastrado com sucesso! Espere autorizao para poder acessar o site...",request);
		redireciona("/login.jsp",request,response);
	}
	private void setMensagem(String mensagem, HttpServletRequest request) {
		request.setAttribute("mensagem", mensagem);
	}
	private void redireciona(String pagina, HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		RequestDispatcher dispatcher = request.getRequestDispatcher(pagina);
		dispatcher.forward(request, response);
	}

}
