package br.usp.ime.forum.servlet;

import java.io.IOException;
import java.util.Arrays;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.usp.ime.forum.business.UsuarioBusiness;
import br.usp.ime.forum.model.Privilegio;
import br.usp.ime.forum.model.Usuario;

@SuppressWarnings("serial")
public class EdicaoTipoUsuarioServlet extends HttpServlet {

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String idUsuarioString = request.getParameter("idUsuario");
		Long idUsuario = Long.valueOf(idUsuarioString);
		preparaUsuario(request, idUsuario);
		preparaTiposDeUsuario(request);
		despachaParaPagina(request, response);
	}

	private void preparaTiposDeUsuario(HttpServletRequest request) {
		
		List<Privilegio> privilegios = Arrays.asList(Privilegio.values());		
		request.setAttribute("tiposDeUsuario", privilegios);
		
	}

	private void preparaUsuario(HttpServletRequest request, Long idUsuario) {
		UsuarioBusiness business = new UsuarioBusiness();
		Usuario usuario = business.getUsuarioPorId(idUsuario);
		request.setAttribute("usuario", usuario);
	}

	private void despachaParaPagina(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		RequestDispatcher dispatcher = request.getRequestDispatcher("/alterar_tipo_usuario.jsp");
		dispatcher.forward(request, response);
	}

}
