package br.usp.ime.forum.servlet;

import java.io.IOException;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.usp.ime.forum.business.AssuntoBusiness;
import br.usp.ime.forum.model.Assunto;

@SuppressWarnings("serial")
public class ListarAssuntosServlet extends HttpServlet {

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		AssuntoBusiness business = new AssuntoBusiness();
		List<Assunto> assuntos = business.getTodosOsAssuntos();
		request.setAttribute("assuntos", assuntos);
		redirecionaParaAssuntos(request, response);
	}
	
	@Override
	protected void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		doGet(request, response);
	}

	private void redirecionaParaAssuntos(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		RequestDispatcher dispatcher = request.getRequestDispatcher("/assuntos.jsp");
		dispatcher.forward(request, response);
	}


}
