package br.usp.ime.forum.servlet;

import java.io.IOException;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.usp.ime.forum.business.AssuntoBusiness;
import br.usp.ime.forum.business.TopicoBusiness;
import br.usp.ime.forum.model.Assunto;
import br.usp.ime.forum.model.Topico;

/**
 * Servlet implementation class ListarTopicos
 */
public class ListarTopicosServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public ListarTopicosServlet() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doPost(request, response);
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		
		TopicoBusiness business = new TopicoBusiness();
		List<Topico> topicos = business.listarTodos();
		request.getSession().setAttribute("topicos", topicos);
		redirecionaParaTopicos(request, response);
	}
	
	private void redirecionaParaTopicos(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		RequestDispatcher dispatcher = request.getRequestDispatcher("/topicos.jsp");
		dispatcher.forward(request, response);
	}

}
