package br.usp.ime.forum.servlet;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import br.usp.ime.forum.business.UsuarioBusiness;
import br.usp.ime.forum.ex.UsuarioNaoAutenticadoException;
import br.usp.ime.forum.ex.UsuarioNaoAutorizadoException;
import br.usp.ime.forum.model.Usuario;

@SuppressWarnings("serial")
public class LoginServlet extends HttpServlet {

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String usuario = request.getParameter("usuario");
		String senha = request.getParameter("senha");
		UsuarioBusiness business = new UsuarioBusiness();
		try {
			Usuario usuarioAutenticado = business.logar(usuario,senha);
			HttpSession sessao = request.getSession();
			sessao.setAttribute("usuario", usuarioAutenticado);
			redirecionaParaHome(request,response);
		} catch (UsuarioNaoAutenticadoException e) {
			request.setAttribute("erro", "Usurio no autenticado!");
			voltarLogin(request,response);
		} catch (UsuarioNaoAutorizadoException e) {
			request.setAttribute("erro", "Usurio no autorizado!");
			voltarLogin(request,response);
		}
	}

	private void redirecionaParaHome(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		RequestDispatcher dispatcher = request.getRequestDispatcher("/home.jsp");
		dispatcher.forward(request, response);
	}

	private void voltarLogin(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		RequestDispatcher dispatcher = request.getRequestDispatcher("/login.jsp");
		dispatcher.forward(request, response);
	}

}
