package br.usp.ime.forum.servlet;

import java.io.IOException;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import br.usp.ime.forum.business.MensagemBusiness;
import br.usp.ime.forum.business.TopicoBusiness;
import br.usp.ime.forum.model.Mensagem;
import br.usp.ime.forum.model.Topico;
import br.usp.ime.forum.model.Usuario;

@SuppressWarnings("serial")
public class MeusTopicosMensagensServlet extends HttpServlet {

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		HttpSession session = request.getSession();
		Usuario usuario = (Usuario) session.getAttribute("usuario");
		
		preparaTopicos(request, usuario);
		preparaMensagens(request, usuario);
		despachaParaPagina(request,response);
	}

	private void preparaTopicos(HttpServletRequest request, Usuario usuario) {
		TopicoBusiness topicoBusiness = new TopicoBusiness();
		List<Topico> topicos = topicoBusiness.getTopicosDoUsuario(usuario);
		request.setAttribute("topicos", topicos);
	}

	private void preparaMensagens(HttpServletRequest request, Usuario usuario) {
		MensagemBusiness mensagemBusiness = new MensagemBusiness();
		List<Mensagem> mensagens = mensagemBusiness.getMensagensDoUsuario(usuario);
		request.setAttribute("mensagens", mensagens);
	}
	
	private void despachaParaPagina(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException {
		RequestDispatcher dispatcher = request.getRequestDispatcher("meus_topicos_mensagens.jsp");
		dispatcher.forward(request, response);
	}

}
