package br.usp.ime.forum.servlet;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.usp.ime.forum.business.TopicoBusiness;
import br.usp.ime.forum.model.Topico;

@SuppressWarnings("serial")
public class VisualizaTopicoServlet extends HttpServlet {

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String idTopicoString = request.getParameter("idTopico");
		Long idTopico = Long.valueOf(idTopicoString);
		preparaTopico(request, idTopico);
		despachaParaPagina(request, response);
	}
	
	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		super.doPost(req, resp);
	}

	private void preparaTopico(HttpServletRequest request, Long idTopico) {
		TopicoBusiness business = new TopicoBusiness();
		Topico topico = business.getTopicoById(idTopico);
		request.setAttribute("topico", topico);
	}

	private void despachaParaPagina(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		RequestDispatcher dispatcher = request.getRequestDispatcher("/visualizar_topico.jsp");
		dispatcher.forward(request, response);
	}

}
